/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.84 Revision 1.154
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.84 2011/01/28 05:05:13 tampakrap Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.154 2015/06/03 22:36:30 mrueg Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 based ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: KDE 4 ebuilds by default define EAPI="2", this can be redefined but 13# NOTE: KDE 4 ebuilds currently support EAPI 5. This will be
14# eclass will fail with version older than 2. 14# reviewed over time as new EAPI versions are approved.
15
16if [[ -z ${_KDE4_BASE_ECLASS} ]]; then
17_KDE4_BASE_ECLASS=1
18
19# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
20# @DESCRIPTION:
21# If set to "none", do nothing.
22# For any other value, add selinux to IUSE, and depending on that useflag
23# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
24: ${KDE_SELINUX_MODULE:=none}
25
26# @ECLASS-VARIABLE: VIRTUALDBUS_TEST
27# @DESCRIPTION:
28# If defined, launch and use a private dbus session during src_test.
15 29
16# @ECLASS-VARIABLE: VIRTUALX_REQUIRED 30# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17# @DESCRIPTION: 31# @DESCRIPTION:
18# Do we need an X server? Valid values are "always", "optional", and "manual". 32# For proper description see virtualx.eclass manpage.
19# "tests" is a synonym for "optional". While virtualx.eclass supports in principle 33# Here we redefine default value to be manual, if your package needs virtualx
20# also the use of an X server during other ebuild phases, we only use it in 34# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
21# src_test here. Most likely you'll want to set "optional", which introduces the
22# use-flag "test" (if not already present), adds dependencies conditional on that
23# use-flag, and automatically runs (only) the ebuild test phase with a virtual X server
24# present. This makes things a lot more comfortable than the bare virtualx eclass.
25
26# In case the variable is not set in the ebuild, let virtualx eclass not do anything
27: ${VIRTUALX_REQUIRED:=manual} 35: ${VIRTUALX_REQUIRED:=manual}
28 36
29inherit kde4-functions base virtualx eutils 37inherit kde4-functions toolchain-funcs fdo-mime flag-o-matic gnome2-utils virtualx versionator eutils multilib
30 38
31get_build_type
32if [[ ${BUILD_TYPE} = live ]]; then 39if [[ ${KDE_BUILD_TYPE} = live ]]; then
33 if [[ ${KDEBASE} = kdevelop ]]; then 40 case ${KDE_SCM} in
34 inherit git
35 else
36 inherit subversion 41 svn) inherit subversion ;;
37 fi 42 git) inherit git-r3 ;;
43 esac
38fi 44fi
39 45
40# @ECLASS-VARIABLE: CMAKE_REQUIRED 46# @ECLASS-VARIABLE: CMAKE_REQUIRED
41# @DESCRIPTION: 47# @DESCRIPTION:
42# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'. 48# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
47if [[ ${CMAKE_REQUIRED} = always ]]; then 53if [[ ${CMAKE_REQUIRED} = always ]]; then
48 buildsystem_eclass="cmake-utils" 54 buildsystem_eclass="cmake-utils"
49 export_fns="src_configure src_compile src_test src_install" 55 export_fns="src_configure src_compile src_test src_install"
50fi 56fi
51 57
52# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here)
53if [[ -n ${KDE_MINIMAL} ]]; then
54 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
55 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break
56 done
57 unset slot
58 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL
59else
60 KDE_MINIMAL_VALID=1
61fi
62
63# @ECLASS-VARIABLE: KDE_MINIMAL 58# @ECLASS-VARIABLE: KDE_MINIMAL
64# @DESCRIPTION: 59# @DESCRIPTION:
65# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal 60# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
66# version for apps to work. Currently defaults to 4.4 61# version for apps to work. Currently defaults to 4.4
67# One may override this variable to raise version requirements. 62# One may override this variable to raise version requirements.
68# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables.
69# Note that it is fixed to ${SLOT} for kde-base packages. 63# Note that it is fixed to ${PV} for kde-base packages.
70KDE_MINIMAL="${KDE_MINIMAL:-4.4}" 64KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
71 65
72# Set slot for packages in kde-base, koffice and kdevelop 66# Set slot for KDEBASE known packages
73case ${KDEBASE} in 67case ${KDEBASE} in
74 kde-base) 68 kde-base)
75 # Determine SLOT from PVs 69 SLOT=4/$(get_version_component_range 1-2)
76 case ${PV} in
77 *.9999*) SLOT="${PV/.9999*/}" ;; # stable live
78 4.6* | 4.5.[6-9][0-9]*) SLOT="4.6" ;;
79 4.5* | 4.4.[6-9][0-9]*) SLOT="4.5" ;;
80 4.4* | 4.3.[6-9][0-9]*) SLOT="4.4" ;;
81 9999*) SLOT="live" ;; # regular live
82 *) die "Unsupported ${PV}" ;;
83 esac
84 KDE_MINIMAL="${SLOT}" 70 KDE_MINIMAL="${PV}"
85 ;;
86 koffice)
87 SLOT="2"
88 ;; 71 ;;
89 kdevelop) 72 kdevelop)
90 if [[ ${BUILD_TYPE} = live ]]; then 73 if [[ ${KDE_BUILD_TYPE} = live ]]; then
91 # @ECLASS-VARIABLE: KDEVELOP_VERSION 74 # @ECLASS-VARIABLE: KDEVELOP_VERSION
92 # @DESCRIPTION: 75 # @DESCRIPTION:
93 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages. 76 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
94 # Applies to KDEBASE=kdevelop only. 77 # Applies to KDEBASE=kdevelop only.
95 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}" 78 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.9999}"
96 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION 79 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
97 # @DESCRIPTION: 80 # @DESCRIPTION:
98 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages. 81 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
99 # Applies to KDEBASE=kdevelop only. 82 # Applies to KDEBASE=kdevelop only.
100 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}" 83 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-4.9999}"
101 else 84 else
102 case ${PN} in 85 case ${PN} in
103 kdevelop|quanta) 86 kdevelop)
104 KDEVELOP_VERSION=${PV} 87 KDEVELOP_VERSION=${PV}
105 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)" 88 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
106 ;; 89 ;;
107 kdevplatform) 90 kdevplatform|kdevelop-php*|kdevelop-python)
108 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)" 91 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
109 KDEVPLATFORM_VERSION=${PV} 92 KDEVPLATFORM_VERSION=${PV}
110 ;; 93 ;;
111 *) 94 *)
112 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}" 95 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
115 fi 98 fi
116 SLOT="4" 99 SLOT="4"
117 ;; 100 ;;
118esac 101esac
119 102
120slot_is_at_least 4.5 ${KDE_MINIMAL} && CMAKE_MIN_VERSION="2.8.1"
121
122inherit ${buildsystem_eclass} 103inherit ${buildsystem_eclass}
123 104
124EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_postinst pkg_postrm 105EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
125 106
126unset buildsystem_eclass 107unset buildsystem_eclass
127unset export_fns 108unset export_fns
128 109
129# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED 110# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
130# @DESCRIPTION: 111# @DESCRIPTION:
131# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'. 112# Is qtdeclarative required? Possible values are 'always', 'optional' and 'never'.
132# This variable must be set before inheriting any eclasses. Defaults to 'never'. 113# This variable must be set before inheriting any eclasses. Defaults to 'never'.
133DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}" 114DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
134 115
135# @ECLASS-VARIABLE: QTHELP_REQUIRED 116# @ECLASS-VARIABLE: QTHELP_REQUIRED
136# @DESCRIPTION: 117# @DESCRIPTION:
137# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'. 118# Is qthelp required? Possible values are 'always', 'optional' and 'never'.
138# This variable must be set before inheriting any eclasses. Defaults to 'never'. 119# This variable must be set before inheriting any eclasses. Defaults to 'never'.
139QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}" 120QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
140 121
141# @ECLASS-VARIABLE: OPENGL_REQUIRED 122# @ECLASS-VARIABLE: OPENGL_REQUIRED
142# @DESCRIPTION: 123# @DESCRIPTION:
143# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 124# Is qtopengl required? Possible values are 'always', 'optional' and 'never'.
144# This variable must be set before inheriting any eclasses. Defaults to 'never'. 125# This variable must be set before inheriting any eclasses. Defaults to 'never'.
145OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 126OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
146 127
147# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED 128# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
148# @DESCRIPTION: 129# @DESCRIPTION:
149# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'. 130# Is qtmultimedia required? Possible values are 'always', 'optional' and 'never'.
150# This variable must be set before inheriting any eclasses. Defaults to 'never'. 131# This variable must be set before inheriting any eclasses. Defaults to 'never'.
151MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}" 132MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
152
153# @ECLASS-VARIABLE: WEBKIT_REQUIRED
154# @DESCRIPTION:
155# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
156# This variable must be set before inheriting any eclasses. Defaults to 'never'.
157WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
158 133
159# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 134# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
160# @DESCRIPTION: 135# @DESCRIPTION:
161# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 136# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
162# This variable must be set before inheriting any eclasses. Defaults to 'never'. 137# This variable must be set before inheriting any eclasses. Defaults to 'never'.
177# This variable must be set before inheriting any eclasses. Defaults to 'never'. 152# This variable must be set before inheriting any eclasses. Defaults to 'never'.
178# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it 153# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
179# ensures buildtime and runtime dependencies. 154# ensures buildtime and runtime dependencies.
180KDE_HANDBOOK="${KDE_HANDBOOK:-never}" 155KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
181 156
157# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
158# @DESCRIPTION:
159# Set this varible if you want your live package to manage its
160# translations. (Mostly all kde ebuilds does not ship documentation
161# and translations in live ebuilds)
162if [[ ${KDE_BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
163 # Kdebase actualy provides the handbooks even for live stuff
164 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
165 KDE_LINGUAS=""
166fi
167
182# Setup packages inheriting this eclass 168# Setup packages inheriting this eclass
183case ${KDEBASE} in 169case ${KDEBASE} in
184 kde-base) 170 kde-base)
185 HOMEPAGE="http://www.kde.org/" 171 HOMEPAGE="http://www.kde.org/"
186 LICENSE="GPL-2" 172 LICENSE="GPL-2"
187 if [[ $BUILD_TYPE = live ]]; then 173 if [[ ${KDE_BUILD_TYPE} = live && -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
188 # Disable tests for live ebuilds 174 # Disable tests for live ebuilds by default
189 RESTRICT+=" test" 175 RESTRICT+=" test"
190 # Live ebuilds in kde-base default to kdeprefix by default
191 IUSE+=" +kdeprefix"
192 else
193 # All other ebuild types default to -kdeprefix as before
194 IUSE+=" kdeprefix"
195 fi 176 fi
177
196 # This code is to prevent portage from searching GENTOO_MIRRORS for 178 # This code is to prevent portage from searching GENTOO_MIRRORS for
197 # packages that will never be mirrored. (As they only will ever be in 179 # packages that will never be mirrored. (As they only will ever be in
198 # the overlay). 180 # the overlay).
199 case ${PV} in 181 case ${PV} in
200 *9999* | 4.?.[6-9]?) 182 *9999* | 4.?.[6-9]? | 4.??.[6-9]? | ??.?.[6-9]? | ??.??.[6-9]?)
201 RESTRICT+=" mirror" 183 RESTRICT+=" mirror"
202 ;; 184 ;;
203 esac 185 esac
204 # Block installation of other SLOTS unless kdeprefix
205 RDEPEND+=" $(block_other_slots)"
206 ;;
207 koffice)
208 HOMEPAGE="http://www.koffice.org/"
209 LICENSE="GPL-2"
210 ;; 186 ;;
211 kdevelop) 187 kdevelop)
212 HOMEPAGE="http://www.kdevelop.org/" 188 HOMEPAGE="http://www.kdevelop.org/"
213 LICENSE="GPL-2" 189 LICENSE="GPL-2"
214 ;; 190 ;;
215esac 191esac
216 192
217# @ECLASS-VARIABLE: QT_MINIMAL 193# @ECLASS-VARIABLE: QT_MINIMAL
218# @DESCRIPTION: 194# @DESCRIPTION:
219# Determine version of qt we enforce as minimal for the package. 4.4.0 4.5.1... 195# Determine version of qt we enforce as minimal for the package.
220# 4.6.0 for 4.4, 4.6.3 for 4.5, and 4.7.0 for 4.6 and later
221if slot_is_at_least 4.6 "${KDE_MINIMAL}"; then
222 QT_MINIMAL="${QT_MINIMAL:-4.7.0}" 196QT_MINIMAL="${QT_MINIMAL:-4.8.5}"
223elif slot_is_at_least 4.5 "${KDE_MINIMAL}"; then
224 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
225else
226 QT_MINIMAL="${QT_MINIMAL:-4.6.0}"
227fi
228 197
229# Declarative dependencies 198# Declarative dependencies
230qtdeclarativedepend=" 199qtdeclarativedepend="
231 >=x11-libs/qt-declarative-${QT_MINIMAL}:4 200 >=dev-qt/qtdeclarative-${QT_MINIMAL}:4
232" 201"
233case ${DECLARATIVE_REQUIRED} in 202case ${DECLARATIVE_REQUIRED} in
234 always) 203 always)
235 COMMONDEPEND+=" ${qtdeclarativedepend}" 204 COMMONDEPEND+=" ${qtdeclarativedepend}"
236 ;; 205 ;;
242esac 211esac
243unset qtdeclarativedepend 212unset qtdeclarativedepend
244 213
245# QtHelp dependencies 214# QtHelp dependencies
246qthelpdepend=" 215qthelpdepend="
247 >=x11-libs/qt-assistant-${QT_MINIMAL}:4 216 >=dev-qt/qthelp-${QT_MINIMAL}:4
248" 217"
249case ${QTHELP_REQUIRED} in 218case ${QTHELP_REQUIRED} in
250 always) 219 always)
251 COMMONDEPEND+=" ${qthelpdepend}" 220 COMMONDEPEND+=" ${qthelpdepend}"
252 ;; 221 ;;
257esac 226esac
258unset qthelpdepend 227unset qthelpdepend
259 228
260# OpenGL dependencies 229# OpenGL dependencies
261qtopengldepend=" 230qtopengldepend="
262 >=x11-libs/qt-opengl-${QT_MINIMAL}:4 231 >=dev-qt/qtopengl-${QT_MINIMAL}:4
263" 232"
264case ${OPENGL_REQUIRED} in 233case ${OPENGL_REQUIRED} in
265 always) 234 always)
266 COMMONDEPEND+=" ${qtopengldepend}" 235 COMMONDEPEND+=" ${qtopengldepend}"
267 ;; 236 ;;
273esac 242esac
274unset qtopengldepend 243unset qtopengldepend
275 244
276# MultiMedia dependencies 245# MultiMedia dependencies
277qtmultimediadepend=" 246qtmultimediadepend="
278 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4 247 >=dev-qt/qtmultimedia-${QT_MINIMAL}:4
279" 248"
280case ${MULTIMEDIA_REQUIRED} in 249case ${MULTIMEDIA_REQUIRED} in
281 always) 250 always)
282 COMMONDEPEND+=" ${qtmultimediadepend}" 251 COMMONDEPEND+=" ${qtmultimediadepend}"
283 ;; 252 ;;
286 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )" 255 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
287 ;; 256 ;;
288 *) ;; 257 *) ;;
289esac 258esac
290unset qtmultimediadepend 259unset qtmultimediadepend
291
292# WebKit dependencies
293case ${KDE_REQUIRED} in
294 always)
295 qtwebkitusedeps="[kde]"
296 ;;
297 optional)
298 qtwebkitusedeps="[kde?]"
299 ;;
300 *) ;;
301esac
302qtwebkitdepend="
303 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
304"
305unset qtwebkitusedeps
306case ${WEBKIT_REQUIRED} in
307 always)
308 COMMONDEPEND+=" ${qtwebkitdepend}"
309 ;;
310 optional)
311 IUSE+=" webkit"
312 COMMONDEPEND+=" webkit? ( ${qtwebkitdepend} )"
313 ;;
314 *) ;;
315esac
316unset qtwebkitdepend
317 260
318# CppUnit dependencies 261# CppUnit dependencies
319cppuintdepend=" 262cppuintdepend="
320 dev-util/cppunit 263 dev-util/cppunit
321" 264"
333 276
334# KDE dependencies 277# KDE dependencies
335# Qt accessibility classes are needed in various places, bug 325461 278# Qt accessibility classes are needed in various places, bug 325461
336kdecommondepend=" 279kdecommondepend="
337 dev-lang/perl 280 dev-lang/perl
281 >=dev-qt/qt3support-${QT_MINIMAL}:4[accessibility]
338 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl] 282 >=dev-qt/qtcore-${QT_MINIMAL}:4[qt3support,ssl]
283 >=dev-qt/qtdbus-${QT_MINIMAL}:4
284 >=dev-qt/designer-${QT_MINIMAL}:4
339 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus] 285 >=dev-qt/qtgui-${QT_MINIMAL}:4[accessibility,dbus(+)]
340 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
341 >=x11-libs/qt-script-${QT_MINIMAL}:4 286 >=dev-qt/qtscript-${QT_MINIMAL}:4
342 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support] 287 >=dev-qt/qtsql-${QT_MINIMAL}:4[qt3support]
343 >=x11-libs/qt-svg-${QT_MINIMAL}:4 288 >=dev-qt/qtsvg-${QT_MINIMAL}:4
344 >=x11-libs/qt-test-${QT_MINIMAL}:4 289 >=dev-qt/qttest-${QT_MINIMAL}:4
345 !aqua? ( 290 >=dev-qt/qtwebkit-${QT_MINIMAL}:4
346 x11-libs/libXext
347 x11-libs/libXt
348 x11-libs/libXxf86vm
349 )
350" 291"
351 292
352if [[ ${PN} != kdelibs ]]; then 293if [[ ${PN} != kdelibs ]]; then
353 kdecommondepend+=" $(add_kdebase_dep kdelibs)" 294 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
354 if [[ ${KDEBASE} = kdevelop ]]; then 295 if [[ ${KDEBASE} = kdevelop ]]; then
359 # Applies to KDEBASE=kdevelop only. 300 # Applies to KDEBASE=kdevelop only.
360 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}" 301 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
361 case ${KDEVPLATFORM_REQUIRED} in 302 case ${KDEVPLATFORM_REQUIRED} in
362 always) 303 always)
363 kdecommondepend+=" 304 kdecommondepend+="
364 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION} 305 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}:4
365 " 306 "
366 ;; 307 ;;
367 *) ;; 308 *) ;;
368 esac 309 esac
369 fi 310 fi
370 fi 311 fi
371fi 312fi
313
372kdedepend=" 314kdedepend="
373 dev-util/automoc 315 dev-util/automoc
374 dev-util/pkgconfig 316 virtual/pkgconfig
375 !aqua? ( 317 !aqua? (
376 >=x11-libs/libXtst-1.1.0 318 >=x11-libs/libXtst-1.1.0
377 x11-proto/xf86vidmodeproto 319 x11-proto/xf86vidmodeproto
378 ) 320 )
379" 321"
322
380kderdepend="" 323kderdepend=""
381 324
325if [[ ${CATEGORY} == kde-apps ]]; then
326 kderdepend+=" !kde-base/${PN}"
327fi
328
329# all packages needs oxygen icons for basic iconset
382if [[ ${PN} != oxygen-icons ]]; then 330if [[ ${PN} != oxygen-icons ]]; then
383 kderdepend+=" $(add_kdebase_dep oxygen-icons)" 331 kderdepend+=" || ( kde-apps/oxygen-icons $(add_kdebase_dep oxygen-icons '' 4.14.3) )"
332fi
333
334# add a dependency over kde-l10n
335if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} ]]; then
336 for _lingua in ${KDE_LINGUAS}; do
337 # if our package has linguas, pull in kde-l10n with selected lingua enabled,
338 # but only for selected ones.
339 # this can't be done on one line because if user doesn't use any localisation
340 # then he is probably not interested in kde-l10n at all.
341 kderdepend+="
342 linguas_${_lingua}? ( || ( kde-apps/kde4-l10n[linguas_${_lingua}(+)] $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") ) )
343 "
344 done
345 unset _lingua
384fi 346fi
385 347
386kdehandbookdepend=" 348kdehandbookdepend="
387 app-text/docbook-xml-dtd:4.2 349 app-text/docbook-xml-dtd:4.2
388 app-text/docbook-xsl-stylesheets 350 app-text/docbook-xsl-stylesheets
402 ;; 364 ;;
403 *) ;; 365 *) ;;
404esac 366esac
405unset kdehandbookdepend kdehandbookrdepend 367unset kdehandbookdepend kdehandbookrdepend
406 368
369case ${KDE_SELINUX_MODULE} in
370 none) ;;
371 *)
372 IUSE+=" selinux"
373 kderdepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
374 ;;
375esac
376
377# We always need the aqua useflag because otherwise we cannot = refer to it inside
378# add_kdebase_dep. This was always kind of a bug, but came to light with EAPI=5
379# (where referring to a use flag not in IUSE masks the ebuild).
380# The only alternative would be to prohibit using add_kdebase_dep if KDE_REQUIRED=never
381IUSE+=" aqua"
382
407case ${KDE_REQUIRED} in 383case ${KDE_REQUIRED} in
408 always) 384 always)
409 IUSE+=" aqua"
410 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}" 385 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
411 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}" 386 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
412 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}" 387 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
413 ;; 388 ;;
414 optional) 389 optional)
415 IUSE+=" aqua kde" 390 IUSE+=" kde"
416 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )" 391 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
417 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )" 392 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
418 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )" 393 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
419 ;; 394 ;;
420 *) ;; 395 *) ;;
429# Accumulate dependencies set by this eclass 404# Accumulate dependencies set by this eclass
430DEPEND+=" ${COMMONDEPEND}" 405DEPEND+=" ${COMMONDEPEND}"
431RDEPEND+=" ${COMMONDEPEND}" 406RDEPEND+=" ${COMMONDEPEND}"
432unset COMMONDEPEND 407unset COMMONDEPEND
433 408
434# Add experimental kdeenablefinal, disabled by default
435IUSE+=" kdeenablefinal"
436
437# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 409# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
438# koffice ebuild, the URI should be set in the ebuild itself 410# kdevelop ebuild, the URI should be set in the ebuild itself
439case ${BUILD_TYPE} in 411_calculate_src_uri() {
440 live) 412 debug-print-function ${FUNCNAME} "$@"
413
414 local _kmname _kmname_pv
415
416 # we calculate URI only for known KDEBASE modules
417 [[ -n ${KDEBASE} ]] || return
418
419 # calculate tarball module name
420 if [[ -n ${KMNAME} ]]; then
421 _kmname="${KMNAME}"
422 else
423 _kmname=${PN}
424 fi
425 _kmname_pv="${_kmname}-${PV}"
426 case ${KDEBASE} in
427 kde-base)
428 case ${PV} in
429 4.4.11.1)
430 # KDEPIM 4.4, special case
431 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
432 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" ;;
433 4.?.[6-9]? | 4.??.[6-9]?)
434 # Unstable KDE SC releases
435 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.xz" ;;
436 4.11.14)
437 # Part of 4.14 actually, sigh. Not stable for next release!
438 SRC_URI="mirror://kde/stable/4.14.3/src/${_kmname_pv}.tar.xz" ;;
439 4.11.17)
440 # Part of 14.12.3 actually, sigh. Not stable for next release!
441 SRC_URI="mirror://kde/stable/applications/14.12.3/src/${_kmname_pv}.tar.xz" ;;
442 4.11.18)
443 # Part of 15.04.0 actually, sigh. Not stable for next release!
444 SRC_URI="mirror://kde/stable/applications/15.04.0/src/${_kmname_pv}.tar.xz" ;;
445 4.11.19)
446 # Part of 15.04.1 actually, sigh. Not stable for next release!
447 SRC_URI="mirror://kde/stable/applications/15.04.1/src/${_kmname_pv}.tar.xz" ;;
448 4.11.20)
449 # Part of 15.04.2 actually, sigh. Not stable for next release!
450 SRC_URI="mirror://kde/stable/applications/15.04.2/src/${_kmname_pv}.tar.xz" ;;
451 4.14.6)
452 # Part of 14.12.3 actually, sigh. Not stable for next release!
453 SRC_URI="mirror://kde/stable/applications/14.12.3/src/${_kmname_pv}.tar.xz" ;;
454 4.14.7)
455 # Part of 15.04.0 actually, sigh. Not stable for next release!
456 SRC_URI="mirror://kde/stable/applications/15.04.0/src/${_kmname_pv}.tar.xz" ;;
457 4.14.8)
458 # Part of 15.04.1 actually, sigh. Not stable for next release!
459 SRC_URI="mirror://kde/stable/applications/15.04.1/src/${_kmname_pv}.tar.xz" ;;
460 4.14.9)
461 # Part of 15.04.2 actually, sigh. Not stable for next release!
462 SRC_URI="mirror://kde/stable/applications/15.04.2/src/${_kmname_pv}.tar.xz" ;;
463 ??.?.[6-9]? | ??.??.[4-9]?)
464 # Unstable KDE Applications releases
465 SRC_URI="mirror://kde/unstable/applications/${PV}/src/${_kmname}-${PV}.tar.xz" ;;
466 *)
467 if [[ ${CATEGORY} == kde-apps ]]; then
468 # Stable KDE Applications releases
469 SRC_URI="mirror://kde/stable/applications/${PV}/src/${_kmname}-${PV}.tar.xz"
470 else
471 # Stable KDE SC releases
472 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.xz"
473 fi
474 ;;
475 esac
476 ;;
477 kdevelop|kdevelop-php*|kdevplatform)
478 case ${KDEVELOP_VERSION} in
479 4.[123].[6-9]*) SRC_URI="mirror://kde/unstable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.xz" ;;
480 *) SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.xz" ;;
481 esac
482 ;;
483 esac
484}
485
486_calculate_live_repo() {
487 debug-print-function ${FUNCNAME} "$@"
488
441 SRC_URI="" 489 SRC_URI=""
442 if has subversion ${INHERITED}; then 490 case ${KDE_SCM} in
491 svn)
443 # Determine branch URL based on live type 492 # Determine branch URL based on live type
444 local branch_prefix 493 local branch_prefix
445 case ${PV} in 494 case ${PV} in
446 9999*) 495 9999*)
447 # trunk 496 # trunk
448 branch_prefix="trunk/KDE" 497 branch_prefix="trunk/KDE"
449 ;; 498 ;;
450 *) 499 *)
451 # branch 500 # branch
452 branch_prefix="branches/KDE/${SLOT}" 501 branch_prefix="branches/KDE/$(get_kde_version)"
453 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX 502 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
454 # @DESCRIPTION 503 # @DESCRIPTION
455 # Suffix appended to ESVN_PROJECT depending on fetched branch. 504 # Suffix appended to ESVN_PROJECT depending on fetched branch.
456 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise. 505 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
457 ESVN_PROJECT_SUFFIX="-${PV}" 506 ESVN_PROJECT_SUFFIX="-${PV}"
490 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta 539 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
491 # build packages from same svn location. 540 # build packages from same svn location.
492 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}" 541 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
493 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}" 542 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
494 ;; 543 ;;
495 koffice)
496 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
497 ;;
498 *) 544 *)
499 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}" 545 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
500 ;; 546 ;;
501 esac 547 esac
502 else 548 else
505 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}" 551 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
506 fi 552 fi
507 # @ECLASS-VARIABLE: ESVN_UP_FREQ 553 # @ECLASS-VARIABLE: ESVN_UP_FREQ
508 # @DESCRIPTION: 554 # @DESCRIPTION:
509 # This variable is used for specifying the timeout between svn synces 555 # This variable is used for specifying the timeout between svn synces
510 # for kde-base and koffice modules. Does not affect misc apps. 556 # for kde-base modules. Does not affect misc apps.
511 # Default value is 1 hour. 557 # Default value is 1 hour.
512 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1} 558 [[ ${KDEBASE} = kde-base ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
513 elif has git ${INHERITED}; then
514 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
515 KMMODULE="${PN}"
516 fi
517 case ${KDEBASE} in
518 kdevelop)
519 EGIT_REPO_URI="git://git.kde.org/${KMMODULE}"
520 ;;
521 esac
522 fi
523 ;; 559 ;;
524 *) 560 git)
561 local _kmname
562 # @ECLASS-VARIABLE: EGIT_MIRROR
563 # @DESCRIPTION:
564 # This variable allows easy overriding of default kde mirror service
565 # (anongit) with anything else you might want to use.
566 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
567
568 # @ECLASS-VARIABLE: EGIT_REPONAME
569 # @DESCRIPTION:
570 # This variable allows overriding of default repository
571 # name. Specify only if this differ from PN and KMNAME.
525 if [[ -n ${KDEBASE} ]]; then 572 if [[ -n ${EGIT_REPONAME} ]]; then
573 # the repository and kmname different
574 _kmname=${EGIT_REPONAME}
526 if [[ -n ${KMNAME} ]]; then 575 elif [[ -n ${KMNAME} ]]; then
527 case ${KMNAME} in
528 kdebase-apps)
529 _kmname="kdebase" ;;
530 *)
531 _kmname="${KMNAME}" ;; 576 _kmname=${KMNAME}
532 esac
533 else 577 else
534 _kmname=${PN} 578 _kmname=${PN}
535 fi 579 fi
536 _kmname_pv="${_kmname}-${PV}" 580
537 case ${KDEBASE} in 581 # default branching
538 kde-base) 582 [[ ${PV} != 4.9999* && ${PV} != 9999 && ${KDEBASE} == kde-base ]] && \
539 case ${PV} in 583 EGIT_BRANCH="KDE/$(get_kde_version)"
540 4.5.93) 584
541 # Only kdepim and kdepim-runtime 4.6beta here 585 # Applications branching
542 SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname}-4.6beta3.tar.bz2" 586 [[ ${PV} == ??.??.49.9999 && ${KDEBASE} == kde-base ]] && \
543 ;; 587 EGIT_BRANCH="Applications/$(get_kde_version)"
544 4.[456].8[05] | 4.[456].9[023568]) 588
545 # Unstable KDE SC releases 589 # default repo uri
546 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" 590 EGIT_REPO_URI+=( "${EGIT_MIRROR}/${_kmname}" )
547 ;; 591
548 4.4.6 | 4.4.7 | 4.4.8 | 4.4.9 | 4.4.10) 592 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
549 # Only kdepim here 593 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
550 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2"
551 ;;
552 *)
553 # Stable KDE SC releases
554 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2"
555 ;;
556 esac
557 ;;
558 koffice)
559 case ${PV} in
560 2.1.[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
561 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
562 esac
563 ;;
564 kdevelop)
565 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
566 ;;
567 esac
568 unset _kmname _kmname_pv
569 fi
570 ;; 594 ;;
595 esac
596}
597
598case ${KDE_BUILD_TYPE} in
599 live) _calculate_live_repo ;;
600 *) _calculate_src_uri ;;
571esac 601esac
572 602
573debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}" 603debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
574 604
575# @ECLASS-VARIABLE: PREFIX 605# @ECLASS-VARIABLE: PREFIX
576# @DESCRIPTION: 606# @DESCRIPTION:
577# Set the installation PREFIX for non kde-base applications. It defaults to /usr. 607# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
578# kde-base packages go into KDE4 installation directory (KDEDIR) by default. 608# kde-base packages go into KDE4 installation directory (/usr).
579# No matter the PREFIX, package will be built against KDE installed in KDEDIR. 609# No matter the PREFIX, package will be built against KDE installed in /usr.
580 610
581# @FUNCTION: kde4-base_pkg_setup 611# @FUNCTION: kde4-base_pkg_setup
582# @DESCRIPTION: 612# @DESCRIPTION:
583# Do the basic kdeprefix KDEDIR settings and determine with which kde should 613# Do some basic settings
584# optional applications link
585kde4-base_pkg_setup() { 614kde4-base_pkg_setup() {
586 debug-print-function ${FUNCNAME} "$@" 615 debug-print-function ${FUNCNAME} "$@"
587 616
588 # Prefix compat: 617 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
589 if [[ ${EAPI} == 2 ]] && ! use prefix; then 618 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
590 EPREFIX= 619 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
591 EROOT=${ROOT}
592 fi 620 fi
593
594 # Append missing trailing slash character
595 [[ ${EROOT} = */ ]] || EROOT+="/"
596
597 # QA ebuilds
598 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})."
599 621
600 # Don't set KDEHOME during compilation, it will cause access violations 622 # Don't set KDEHOME during compilation, it will cause access violations
601 unset KDEHOME 623 unset KDEHOME
602 624
603 if [[ ${KDEBASE} = kde-base ]]; then 625 # Check if gcc compiler is fresh enough.
604 if use kdeprefix; then 626 # In theory should be in pkg_pretend but we check it only for kdelibs there
605 KDEDIR=/usr/kde/${SLOT} 627 # and for others we do just quick scan in pkg_setup because pkg_pretend
606 else 628 # executions consume quite some time (ie. when merging 300 packages at once will cause 300 checks)
629 if [[ ${MERGE_TYPE} != binary ]]; then
630 [[ $(gcc-major-version) -lt 4 ]] || \
631 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 6 ]] ) \
632 && die "Sorry, but gcc-4.6 and earlier wont work for some KDE packages."
633 fi
634
607 KDEDIR=/usr 635 KDEDIR=/usr
608 fi
609 : ${PREFIX:=${KDEDIR}}
610 else
611 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL
612 KDEDIR=
613 local kde_minimal_met
614 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
615 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1
616 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then
617 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then
618 KDEDIR=/usr/kde/${slot}
619 else
620 KDEDIR=/usr
621 fi
622 break;
623 fi
624 done
625 unset slot
626
627 # Bail out if kdelibs required but not found
628 if [[ ${KDE_REQUIRED} = always ]] || { [[ ${KDE_REQUIRED} = optional ]] && use kde; }; then
629 [[ -z ${KDEDIR} ]] && die "Failed to determine KDEDIR!"
630 else
631 [[ -z ${KDEDIR} ]] && KDEDIR=/usr
632 fi
633
634 : ${PREFIX:=/usr} 636 : ${PREFIX:=/usr}
635 fi 637 EKDEDIR=${EPREFIX}/usr
636 EKDEDIR=${EPREFIX}${KDEDIR}
637 638
638 # Point pkg-config path to KDE *.pc files
639 export PKG_CONFIG_PATH="${EKDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
640 # Point to correct QT plugins path 639 # Point to correct QT plugins path
641 QT_PLUGIN_PATH="${EKDEDIR}/$(get_libdir)/kde4/plugins/" 640 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
642 641
643 # Fix XDG collision with sandbox 642 # Fix XDG collision with sandbox
644 export XDG_CONFIG_HOME="${T}" 643 export XDG_CONFIG_HOME="${T}"
645} 644}
646 645
648# @DESCRIPTION: 647# @DESCRIPTION:
649# This function unpacks the source tarballs for KDE4 applications. 648# This function unpacks the source tarballs for KDE4 applications.
650kde4-base_src_unpack() { 649kde4-base_src_unpack() {
651 debug-print-function ${FUNCNAME} "$@" 650 debug-print-function ${FUNCNAME} "$@"
652 651
653 if [[ ${BUILD_TYPE} = live ]]; then 652 if [[ ${KDE_BUILD_TYPE} = live ]]; then
654 if has subversion ${INHERITED}; then 653 case ${KDE_SCM} in
655 migrate_store_dir 654 svn)
656 subversion_src_unpack 655 subversion_src_unpack
657 elif has git ${INHERITED}; then
658 git_src_unpack
659 fi
660 elif [[ ${EAPI} == 2 ]]; then
661 local file
662 for file in ${A}; do
663 # This setup is because EAPI <= 2 cannot unpack *.tar.xz files
664 # directly, so we do it ourselves (using the exact same code as portage)
665 case ${file} in
666 *.tar.xz)
667 echo ">>> Unpacking ${file} to ${PWD}"
668 xz -dc "${DISTDIR}"/${file} | tar xof -
669 assert "failed unpacking ${file}"
670 ;; 656 ;;
671 *) 657 git)
672 unpack ${file} 658 git-r3_src_unpack
673 ;; 659 ;;
674 esac 660 esac
675 done
676 else 661 else
677 # For EAPI >= 3, we can just use unpack() directly
678 unpack ${A} 662 unpack ${A}
679 fi 663 fi
680} 664}
681 665
682# @FUNCTION: kde4-base_src_prepare 666# @FUNCTION: kde4-base_src_prepare
686# enable_selected_linguas() and enable_selected_doc_linguas() 670# enable_selected_linguas() and enable_selected_doc_linguas()
687# in kde4-functions.eclass(5) for further details. 671# in kde4-functions.eclass(5) for further details.
688kde4-base_src_prepare() { 672kde4-base_src_prepare() {
689 debug-print-function ${FUNCNAME} "$@" 673 debug-print-function ${FUNCNAME} "$@"
690 674
675 # enable handbook and linguas only when not using live ebuild
676
691 # Only enable selected languages, used for KDE extragear apps. 677 # Only enable selected languages, used for KDE extragear apps.
692 if [[ -n ${KDE_LINGUAS} ]]; then 678 if [[ -n ${KDE_LINGUAS} ]]; then
693 enable_selected_linguas 679 enable_selected_linguas
694 fi 680 fi
695 681
696 # Enable/disable handbooks for kde4-base packages 682 # Enable/disable handbooks for kde4-base packages
697 # kde-l10n inherits kde4-base but is metpackage, so no check for doc 683 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
698 # kdelibs inherits kde4-base but handle installing the handbook itself 684 # kdelibs inherits kde4-base but handle installing the handbook itself
699 if ! has kde4-meta ${INHERITED}; then 685 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
700 has handbook ${IUSE//+} && [[ ${PN} != kde-l10n ]] && [[ ${PN} != kdelibs ]] && enable_selected_doc_linguas 686 if [[ ${KDEBASE} == kde-base ]]; then
687 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
688 # documentation in kde4-functions
689 : ${KDE_DOC_DIRS:=doc}
690 local dir
691 for dir in ${KDE_DOC_DIRS}; do
692 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
693 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
694 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
695 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
696 -i CMakeLists.txt || die "failed to comment out handbook"
697 done
698 fi
699 else
700 enable_selected_doc_linguas
701 fi
701 fi 702 fi
702 703
703 # SCM bootstrap 704 # SCM bootstrap
704 if [[ ${BUILD_TYPE} = live ]]; then 705 if [[ ${KDE_BUILD_TYPE} = live ]]; then
705 if has subversion ${INHERITED}; then 706 case ${KDE_SCM} in
706 subversion_src_prepare 707 svn) subversion_src_prepare ;;
707 elif has git ${INHERITED}; then 708 esac
708 git_src_prepare
709 fi 709 fi
710 fi
711 710
712 # Apply patches 711 # Apply patches, cmake-utils does the job already
713 base_src_prepare 712 cmake-utils_src_prepare
714 713
715 # Save library dependencies 714 # Save library dependencies
716 if [[ -n ${KMSAVELIBS} ]] ; then 715 if [[ -n ${KMSAVELIBS} ]] ; then
717 save_library_dependencies 716 save_library_dependencies
718 fi 717 fi
720 # Inject library dependencies 719 # Inject library dependencies
721 if [[ -n ${KMLOADLIBS} ]] ; then 720 if [[ -n ${KMLOADLIBS} ]] ; then
722 load_library_dependencies 721 load_library_dependencies
723 fi 722 fi
724 723
725 # Replace KDE4Workspace library targets
726 find "${S}" -name CMakeLists.txt \
727 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' {} + \
728 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' {} + \
729 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' {} + \
730 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' {} + \
731 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' {} + \
732 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' {} + \
733 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' {} + \
734 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' {} + \
735 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' {} + \
736 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' {} + \
737 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' {} + \
738 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' {} + \
739 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' {} + \
740 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' {} + \
741 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' {} + \
742 || die 'failed to replace KDE4Workspace library targets'
743
744 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/... 724 # Hack for manuals relying on outdated DTD, only outside kde-base/...
745 if [[ -z ${KDEBASE} ]]; then 725 if [[ -z ${KDEBASE} ]]; then
746 find "${S}" -name "*.docbook" \ 726 find "${S}" -name "*.docbook" \
747 -exec sed -i -r \ 727 -exec sed -i -r \
748 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \ 728 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
749 || die 'failed to fix DocBook variant version' 729 || die 'failed to fix DocBook variant version'
757 debug-print-function ${FUNCNAME} "$@" 737 debug-print-function ${FUNCNAME} "$@"
758 738
759 # Build tests in src_test only, where we override this value 739 # Build tests in src_test only, where we override this value
760 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF) 740 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
761 741
762 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then 742 if use_if_iuse debug; then
763 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
764 fi
765
766 if has debug ${IUSE//+} && use debug; then
767 # Set "real" debug mode 743 # Set "real" debug mode
768 CMAKE_BUILD_TYPE="Debugfull" 744 CMAKE_KDE_BUILD_TYPE="Debugfull"
769 else 745 else
770 # Handle common release builds 746 # Handle common release builds
771 append-cppflags -DQT_NO_DEBUG 747 append-cppflags -DQT_NO_DEBUG
772 fi 748 fi
773 749
778 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}") 754 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
779 755
780 # Use colors 756 # Use colors
781 QTEST_COLORED=1 757 QTEST_COLORED=1
782 758
783 # Shadow existing /usr installations 759 # Shadow existing installations
784 unset KDEDIRS 760 unset KDEDIRS
785 761
786 # Handle kdeprefix-ed KDE
787 if [[ ${KDEDIR} != /usr ]]; then
788 # Override some environment variables - only when kdeprefix is different,
789 # to not break ccache/distcc
790 PATH="${EKDEDIR}/bin:${PATH}"
791
792 # Append library search path
793 append-ldflags -L"${EKDEDIR}/$(get_libdir)"
794
795 # Append full RPATH
796 cmakeargs+=(-DCMAKE_SKIP_RPATH=OFF)
797
798 # Set cmake prefixes to allow buildsystem to locate valid KDE installation
799 # when more are present
800 cmakeargs+=(-DCMAKE_SYSTEM_PREFIX_PATH="${EKDEDIR}")
801 fi
802
803 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling 762 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
804 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/lib/qt4) 763 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
805 #kde-config -path data unavailable when cross-compiling 764 #kde-config -path data unavailable when cross-compiling
806 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/) 765 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
807 766
808 # Handle kdeprefix in application itself
809 if ! has kdeprefix ${IUSE//+} || ! use kdeprefix; then
810 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc 767 # sysconf needs to be /etc, not /usr/etc
811 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc) 768 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
812 fi
813 769
814 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then 770 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
771 if [[ ${mycmakeargs} ]]; then
772 eqawarn "mycmakeargs should always be declared as an array, not a string"
773 fi
815 mycmakeargs=(${mycmakeargs}) 774 mycmakeargs=(${mycmakeargs})
816 fi 775 fi
817 776
818 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}") 777 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
819 778
832# @FUNCTION: kde4-base_src_test 791# @FUNCTION: kde4-base_src_test
833# @DESCRIPTION: 792# @DESCRIPTION:
834# Function for testing KDE4 applications. 793# Function for testing KDE4 applications.
835kde4-base_src_test() { 794kde4-base_src_test() {
836 debug-print-function ${FUNCNAME} "$@" 795 debug-print-function ${FUNCNAME} "$@"
796
797 local kded4_pid
798
799 _test_runner() {
800 if [[ -n "${VIRTUALDBUS_TEST}" ]]; then
801 export $(dbus-launch)
802 kded4 2>&1 > /dev/null &
803 kded4_pid=$!
804 fi
805
806 cmake-utils_src_test
807 }
808
809 # When run as normal user during ebuild development with the ebuild command, the
810 # kde tests tend to access the session DBUS. This however is not possible in a real
811 # emerge or on the tinderbox.
812 # > make sure it does not happen, so bad tests can be recognized and disabled
813 unset DBUS_SESSION_BUS_ADDRESS DBUS_SESSION_BUS_PID
837 814
838 # Override this value, set in kde4-base_src_configure() 815 # Override this value, set in kde4-base_src_configure()
839 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON) 816 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
840 cmake-utils_src_configure 817 cmake-utils_src_configure
841 kde4-base_src_compile 818 kde4-base_src_compile
842 819
843 if [[ ${VIRTUALX_REQUIRED} == always ]] || 820 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
844 ( [[ ${VIRTUALX_REQUIRED} != manual ]] && use test ); then 821 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
845 822 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
846 if [[ ${maketype} ]]; then
847 # surprise- we are already INSIDE virtualmake!!! 823 # surprise- we are already INSIDE virtualmake!!!
848 ewarn "QA Notice: This version of kde4-base.eclass includes the virtualx functionality." 824 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
849 ewarn " You may NOT set maketype or call virtualmake from the ebuild. Applying workaround." 825 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
850 cmake-utils_src_test 826 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
827 debug-print " kde4-base.eclass docs for details... Applying workaround."
828 _test_runner
851 else 829 else
852 export maketype="cmake-utils_src_test" 830 VIRTUALX_COMMAND="_test_runner" virtualmake
853 virtualmake
854 fi 831 fi
855 else 832 else
856 cmake-utils_src_test 833 _test_runner
834 fi
835
836 if [ -n "${kded4_pid}" ] ; then
837 kill ${kded4_pid}
838 fi
839
840 if [ -n "${DBUS_SESSION_BUS_PID}" ] ; then
841 kill ${DBUS_SESSION_BUS_PID}
857 fi 842 fi
858} 843}
859 844
860# @FUNCTION: kde4-base_src_install 845# @FUNCTION: kde4-base_src_install
861# @DESCRIPTION: 846# @DESCRIPTION:
862# Function for installing KDE4 applications. 847# Function for installing KDE4 applications.
863kde4-base_src_install() { 848kde4-base_src_install() {
864 debug-print-function ${FUNCNAME} "$@" 849 debug-print-function ${FUNCNAME} "$@"
865
866 # Prefix support, for usage in ebuilds
867 if [[ ${EAPI} == 2 ]] && ! use prefix; then
868 ED=${D}
869 fi
870 850
871 if [[ -n ${KMSAVELIBS} ]] ; then 851 if [[ -n ${KMSAVELIBS} ]] ; then
872 install_library_dependencies 852 install_library_dependencies
873 fi 853 fi
874 854
875 # Install common documentation of KDE4 applications 855 # Install common documentation of KDE4 applications
876 local doc 856 local doc
877 if ! has kde4-meta ${INHERITED}; then 857 if ! has kde4-meta ${INHERITED}; then
878 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do 858 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
879 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}" 859 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
880 done 860 done
881 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do 861 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
882 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})" 862 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
883 done 863 done
884 fi 864 fi
885 865
886 cmake-utils_src_install 866 cmake-utils_src_install
867
868 # We don't want ${PREFIX}/share/doc/HTML to be compressed,
869 # because then khelpcenter can't find the docs
870 [[ -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
871 docompress -x ${PREFIX}/share/doc/HTML
872}
873
874# @FUNCTION: kde4-base_pkg_preinst
875# @DESCRIPTION:
876# Function storing icon caches
877kde4-base_pkg_preinst() {
878 debug-print-function ${FUNCNAME} "$@"
879
880 gnome2_icon_savelist
881 if [[ ${KDE_BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
882 subversion_pkg_preinst
883 fi
887} 884}
888 885
889# @FUNCTION: kde4-base_pkg_postinst 886# @FUNCTION: kde4-base_pkg_postinst
890# @DESCRIPTION: 887# @DESCRIPTION:
891# Function to rebuild the KDE System Configuration Cache after an application has been installed. 888# Function to rebuild the KDE System Configuration Cache after an application has been installed.
892kde4-base_pkg_postinst() { 889kde4-base_pkg_postinst() {
893 debug-print-function ${FUNCNAME} "$@" 890 debug-print-function ${FUNCNAME} "$@"
894 891
892 gnome2_icon_cache_update
893 fdo-mime_desktop_database_update
894 fdo-mime_mime_database_update
895 buildsycoca 895 buildsycoca
896 896
897 if [[ ${BUILD_TYPE} = live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 897 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
898 echo 898 if [[ ${KDE_BUILD_TYPE} = live ]]; then
899 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
900 einfo "Use it at your own risk."
901 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
902 echo
903 elif [[ ${BUILD_TYPE} != live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && has kdeprefix ${IUSE//+} && use kdeprefix; then
904 # warning about kdeprefix for non-live users
905 echo
906 ewarn "WARNING! You have the kdeprefix useflag enabled."
907 ewarn "This setting is strongly discouraged and might lead to potential trouble"
908 ewarn "with KDE update strategies."
909 ewarn "You are using this setup at your own risk and the kde team does not"
910 ewarn "take responsibilities for dead kittens."
911 echo
912 fi
913 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && ! has_version 'kde-base/kdebase-runtime-meta' && ! has_version 'kde-base/kdebase-startkde'; then
914 # warn about not supported approach
915 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
916 echo 899 echo
900 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
901 einfo "Use it at your own risk."
902 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
903 echo
904 fi
905 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
906 if [[ ${KDEBASE} != kde-base ]] && \
907 ! has_version 'kde-base/kdebase-runtime-meta' && \
908 ! has_version 'kde-base/kdebase-startkde'; then
909 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
910 echo
917 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\"" 911 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
918 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above." 912 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
919 ewarn "With this setting you are unsupported by KDE team." 913 ewarn "With this setting you are unsupported by KDE team."
920 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID." 914 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
915 fi
921 fi 916 fi
922 fi 917 fi
923} 918}
924 919
925# @FUNCTION: kde4-base_pkg_postrm 920# @FUNCTION: kde4-base_pkg_postrm
926# @DESCRIPTION: 921# @DESCRIPTION:
927# Function to rebuild the KDE System Configuration Cache after an application has been removed. 922# Function to rebuild the KDE System Configuration Cache after an application has been removed.
928kde4-base_pkg_postrm() { 923kde4-base_pkg_postrm() {
929 debug-print-function ${FUNCNAME} "$@" 924 debug-print-function ${FUNCNAME} "$@"
930 925
926 gnome2_icon_cache_update
927 fdo-mime_desktop_database_update
928 fdo-mime_mime_database_update
931 buildsycoca 929 buildsycoca
932} 930}
931
932fi

Legend:
Removed from v.1.84  
changed lines
  Added in v.1.154

  ViewVC Help
Powered by ViewVC 1.1.20